"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
require("core-js/modules/es.array.iterator.js");
var _objectTools = _interopRequireDefault(require("./object-tools"));
var _orm = _interopRequireDefault(require("./orm"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
exports.getReferenceSchema = function (schemas, modelSchema, associationName) {
  const schemaField = modelSchema.fields.find(function (field) {
    return field.field === associationName;
  });

  // NOTICE: No reference field found, no name transformation tried.
  if (!schemaField || !schemaField.reference) {
    return null;
  }
  const [tableName] = schemaField.reference.split('.');
  return schemas[tableName];
};
exports.getReferenceField = function (schemas, modelSchema, associationName, fieldName) {
  const associationSchema = exports.getReferenceSchema(schemas, modelSchema, associationName, fieldName);

  // NOTICE: No association schema found, no name transformation tried.
  if (!associationSchema) {
    return `${associationName}.${fieldName}`;
  }
  const belongsToColumnName = _orm.default.getColumnName(associationSchema, fieldName);
  return `${associationName}.${belongsToColumnName}`;
};

/**
 * When they don't have common keys, merge objects together.
 * This is used to avoid having too many nested 'AND' conditions on sequelize queries, which
 * makes debugging and testing more painful than it could be.
 */
exports.mergeWhere = function (operators, ...wheres) {
  return wheres.filter(Boolean).reduce(function (where1, where2) {
    return _objectTools.default.plainObjectsShareNoKeys(where1, where2) ? _objectSpread(_objectSpread({}, where1), where2) : {
      [operators.AND]: [where1, where2]
    };
  });
};